#!/usr/bin/env python
# Dump the object tree showing: role, name, parent

import pyatspi

def dump_node_content (node, padding):
    for c in xrange(node.childCount):
        inner_node = node.getChildAtIndex(c)
        string = padding + " -- Role='" + inner_node.getRoleName() + "'"

        string = string + " Name='" + inner_node.name + "'"

        if inner_node.parent is None:
            string = string + " Parent=NULL"
        else:
            string = string + " Parent Name='" + inner_node.parent.name + "'"

        try:
            print string
        except UnicodeEncodeError:
            print "Wrong encoding"

        try:
            dump_node_content(inner_node, padding + "  ")
        except AttributeError:
            print padding+" Wrong node"

if __name__ == "__main__":
    desk = pyatspi.Registry.getDesktop(0)
    for i in xrange(desk.childCount):
        app = desk.getChildAtIndex(i)
        print "Index: %d" % i
        print "Application name: %s" % app.name
        print "Application elements: %d" % app.childCount
        dump_node_content (app, "")
        print
