#!/usr/bin/env python
# Return the hyerarchy with the nodes with name (plain list, not tree) adding the description

import pyatspi

def dump_node_content (node):
    for c in xrange(node.childCount):
        inner_node = node.getChildAtIndex(c)
        try:
            text = inner_node.queryText ()
        except NotImplementedError:
            text = None
        if (inner_node.name != "" or text != None):
            string = "\t" + inner_node.name
            string = string + " [" + inner_node.description + "]"
            if text:
                string = string + " (" + text.getText(0,-1) + ")"
            num_children = inner_node.childCount
            string = string + " (num_children==%d)" % num_children
            string = string + " application=" + inner_node.getApplication ().name
            string = string + " role = " + inner_node.getRoleName ()

            try:
                print string
            except UnicodeEncodeError:
                print "Wrong encoding"

        dump_node_content(inner_node)

if __name__ == "__main__":
    desk = pyatspi.Registry.getDesktop(0)
    for i in xrange(desk.childCount):
        app = desk.getChildAtIndex(i)
        print "Index: %d" % i
        print "Application name: %s" % app.name
        print "Application elements: %d" % app.childCount
        dump_node_content (app)
        print
